import 'package:flutter_test/flutter_test.dart';
import 'package:osam/osam.dart';

void main() {
  test('tests', () async {
    final a = T();
    a.propertyStream((state) => state.value).listen((data) async {
      print(data);
    });
    a.update((state) => state.value = 2);
    a.update((state) => state.value = 3);
    a.update((state) => state.value = 0);

    print('finish');

    await Future.delayed(Duration(seconds: 2));
  });
}

// ignore: must_be_immutable
class T extends BaseState<T> {
  var value = 1;
  var second = 2;

  @override
  List<Object> get props => [value];
}

class E extends T {}

// binary search
//    const target = 3;
//    var list = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9];
//    var start = 0;
//    var end = list.length - 1;
//
//    while (end - start > 1) {
//      final middle = ((end - start) / 2).floor();
//      final index = start + middle;
//      if (list[index] <= target) {
//        start = index;
//      } else if (list[index] >= target) {
//        end = end - middle;
//      }
//      if (list[end] == target) {
//        start = end;
//        end = end + 1;
//        break;
//      }
//    }
//    print(list.sublist(start, end));

//    var extendLeft = 0;
//    while (start - extendLeft > 0) {
//      extendLeft++;
//      if (list[start - extendLeft] != target) {
//        extendLeft--;
//        break;
//      }
//    }

//    print(extendLeft);
//    print(list.sublist(start - extendLeft, end));
